//+------------------------------------------------------------------+
//| T3.mq4 |
//| MojoFX |
//| http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/ |
//+------------------------------------------------------------------+
#property copyright "MojoFX - Conversion only"
#property link "http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
extern int MA_Period = 14;
extern double b = 0.7;
double MapBuffer[];
double e1,e2,e3,e4,e5,e6;
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- 
SetIndexStyle(0,DRAW_LINE);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
IndicatorShortName("T3"+MA_Period);
SetIndexBuffer(0,MapBuffer);
b2=b*b;
b3=b2*b;
c1=-b3;
c2=(3*(b2+b3));
c3=-3*(2*b2+b+b3);
c4=(1+3*b+b3+3*b2);
n=MA_Period;
if (n<1) n=1;
n = 1 + 0.5*(n-1);
w1 = 2 / (n + 1);
w2 = 1 - w1;
//----
return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
// In diesem Fall wird die Indikatoren-Werten auf allen Bars bei jedem Start der Funktion start() ganz neuberechnet
for(int bar=Bars-1; bar>=0; bar--)
/*
Wenn die Zeile "for(int bar=Bars-1; bar>=0; bar--)" mit den 4 unten kommenden Zeilen wechseln, 
um den Indikator nur auf letzten Bars bei jedem Start der Funktion start() neuzuberechnen,
dann wird dieser Indikator nur in der History gut arbeiten:
int  limit,counted_bars=IndicatorCounted();
if(counted_bars>0) counted_bars--;
limit=Bars-1-counted_bars;
for(int bar=limit; bar>=0; bar--)
*/
{
// Variablen e1,e2,e3,e4,e5,e6 sind Funktionen von sich selbst,die in den vorherigen Bars berechnet wurden   
e1 = w1*Close[bar] + w2*e1;
e2 = w1*e1 + w2*e2;
e3 = w1*e2 + w2*e3;
e4 = w1*e3 + w2*e4;
e5 = w1*e4 + w2*e5;
e6 = w1*e5 + w2*e6;

MapBuffer[bar]=c1*e6 + c2*e5 + c3*e4 + c4*e3;
} 
//----
return(0);
}
//+------------------------------------------------------------------+

